// coverage:ignore-file
/// A set of [RequestType] which will be used to make different calls
enum RequestType {
  get,
}

/// Send timeout interval for each request.
const _sendTimeoutRequestDefault = <RequestType, int>{
  RequestType.get: 10000,
};

/// Receive timeout interval for each request.
const _receiveTimeoutRequestDefault = <RequestType, int>{
  RequestType.get: 10000,
};

/// Connect timeout interval for each request.
const _connectTimeoutRequestDefault = <RequestType, int>{
  RequestType.get: 10000,
};

/// An extension on [RequestType] to get the details related to the request
/// like the type and other time out parameters.
extension RequestTypeExtension on RequestType {
  static const methods = <RequestType, String>{
    RequestType.get: 'GET',
  };

  String get method => methods[this]!;

  int get sendTimeout => _sendTimeoutRequestDefault[this]!;

  int get receiveTimeout => _receiveTimeoutRequestDefault[this]!;

  int get connectTimeout => _connectTimeoutRequestDefault[this]!;
}
